
Name:		openmpi_1.10.4_mofed
Version:	201702080423
Release:	hpe_hpcstack%{?dist}
Summary:	Open MPI for Mellanox OFED

License:	BSD
URL:		https://www.open-mpi.org
Source:	openmpi-1.10.4.tar.gz
Patch0:	opal_epoll.patch
Requires: environment-modules
%if 0%{?suse_version} >= 1315
Requires: mlnx-fw-updater = 3.4-2.0.0.0
Requires: fca = 2.5.2431-1.34100
Requires: hcoll = 3.6.1228-1.34100
Requires: libibprof = 1.1.31-1.34100
Requires: mxm = 3.5.3093-1.34100

BuildRequires: mlnx-fw-updater = 3.4-2.0.0.0
BuildRequires: fca = 2.5.2431-1.34100
BuildRequires: hcoll = 3.6.1228-1.34100
BuildRequires: libibprof = 1.1.31-1.34100
BuildRequires: mxm = 3.5.3093-1.34100
%endif

%if 0%{?el7}
Requires: mlnx-fw-updater = 3.4-2.0.0.0
Requires: fca = 2.5.2431-1.34100
Requires: hcoll = 3.6.1228-1.34100
Requires: libibprof = 1.1.31-1.34100
Requires: mxm = 3.5.3093-1.34100

BuildRequires: mlnx-fw-updater = 3.4-2.0.0.0
BuildRequires: fca = 2.5.2431-1.34100
BuildRequires: hcoll = 3.6.1228-1.34100
BuildRequires: libibprof = 1.1.31-1.34100
BuildRequires: mxm = 3.5.3093-1.34100
%endif

AutoReqProv:	no

%define debug_package %{nil}
%define prefix        /opt/hpe/hpc/openmpi/1.10.4/mofed


%description

Open MPI for Mellanox OFED

%prep
%setup -q -n openmpi-1.10.4
%patch -P 0

%build
rm -rf BuildHERE
mkdir BuildHERE
cd BuildHERE
../configure --prefix=/opt/hpe/hpc/openmpi/1.10.4/mofed  	CC=gcc 	CFLAGS=-O3 		F77=gfortran 	FC=gfortran 		--without-mpi-param-check 		--with-pmi=/opt/hpe/hpc/slurm/default 	--with-devel-headers 		--enable-dlopen 		--disable-vt 		--enable-mpirun-prefix-by-default 		--enable-orterun-prefix-by-default 		--enable-debug-symbols  	--with-knem=/opt/mellanox/hpcx/knem 	--with-platform=../contrib/platform/mellanox/optimized 	--with-mxm=/opt/mellanox/hpcx/mxm  	--with-mxm-libdir=/opt/mellanox/hpcx/mxm/lib 	--with-hcoll=/opt/mellanox/hpcx/hcoll 	--without-psm 	--without-psm2 	--disable-dlopen
make -j 4
make DESTDIR=/tmp/root/openmpi-1.10.4_mofed-sjJmBqWe2 install
cd -

%check

%install

rm -rf %{buildroot}
mv -f /tmp/root/openmpi-1.10.4_mofed-sjJmBqWe2 %{buildroot}


mkdir -p %{buildroot}/opt/hpe/hpc/modules/openmpi/1.10.4
cat >%{buildroot}/opt/hpe/hpc/modules/openmpi/1.10.4/mofed <<-'EOF'
#%Module1.0

# Module file for openmpi-1.10.4_mofed

proc ModulesHelp { } {
puts stderr "Set up the paths for openmpi-1.10.4_mofed"
}

conflict mvapich2
conflict openmpi
conflict shmem

set path        /opt/hpe/hpc/openmpi/1.10.4/mofed
set ver         1.10.4_mofed

set dependencyList {gcc}
set missingModules { }

if { [ module-info mode load ] } {
set missing false
foreach dep $dependencyList {
if { ! [ is-loaded $dep ] } {
lappend missingModules $dep
set missing true
}
}
if { $missing == true } {
puts -nonewline stderr "Load Failed! The following dependency module(s) must be loaded before loading this module:"
foreach miss $missingModules {
puts -nonewline stderr " $miss"
}
puts stderr "."
exit 1
}
}

prepend-path PATH /opt/hpe/hpc/openmpi/1.10.4/mofed/bin:/opt/mellanox/hpcx/mxm/bin:/opt/mellanox/hpcx/hcoll/bin
prepend-path CPATH /opt/hpe/hpc/openmpi/1.10.4/mofed/include:/opt/mellanox/hpcx/mxm/include:/opt/mellanox/hpcx/hcoll/include
prepend-path FPATH /opt/hpe/hpc/openmpi/1.10.4/mofed/include:/opt/mellanox/hpcx/mxm/include:/opt/mellanox/hpcx/hcoll/include
prepend-path MANPATH /opt/hpe/hpc/openmpi/1.10.4/mofed/share/man
prepend-path LIBRARY_PATH /opt/hpe/hpc/openmpi/1.10.4/mofed/lib:/opt/mellanox/hpcx/mxm/lib:/opt/mellanox/hpcx/hcoll/lib
prepend-path LD_LIBRARY_PATH /opt/hpe/hpc/openmpi/1.10.4/mofed/lib:/opt/mellanox/hpcx/mxm/lib:/opt/mellanox/hpcx/hcoll/lib

prepend-path COMM_LDFLAGS "-L/opt/hpe/hpc/openmpi/1.10.4/mofed/lib -L/opt/hpe/hpc/slurm/default/lib -L/opt/mellanox/hpcx/mxm/lib -L/opt/mellanox/hpcx/hcoll/lib -Xlinker -rpath=/opt/hpe/hpc/openmpi/1.10.4/mofed/lib:/opt/hpe/hpc/slurm/default/lib:/opt/mellanox/hpcx/mxm/lib:/opt/mellanox/hpcx/hcoll/lib"

setenv SHMEM_SYMMETRIC_HEAP_SIZE 4500M
setenv SLURM_PMI_KVS_NO_DUP_KEYS 1
setenv MXM_OSHMEM_TLS ud,self
setenv OMPI_MCA_pml yalla
setenv OMPI_MCA_spml_ikrit_hw_rdma_channel 0
setenv MXM_SHM_USE_KNEM_DMA y
setenv OMPI_MCA_sshmem mmap
setenv MXSHMEM_VER 1.10.4_mofed
setenv MXM_FAST_TIMER_RESOLUTION 256.00us
setenv MXM_MPI_TLS ud,shm,self
setenv MXM_UD_FAST_ACK_TIMEOUT 16384.00us
setenv OPENMPI_PATH /opt/hpe/hpc/openmpi/1.10.4/mofed

EOF
mkdir -p %{buildroot}/opt/hpe/hpc/modules/shmem/1.10.4
cat >%{buildroot}/opt/hpe/hpc/modules/shmem/1.10.4/mofed <<-EOF
#%Module1.0

# Module file for shmem 1.10.4_mofed

proc ModulesHelp { } {
puts stderr "Set up the paths for shmem 1.10.4/mofed"
}

conflict mvapich2

prepend-path PATH /opt/hpe/hpc/openmpi/1.10.4/mofed/bin:/opt/mellanox/hpcx/mxm/bin:/opt/mellanox/hpcx/hcoll/bin
prepend-path CPATH /opt/hpe/hpc/openmpi/1.10.4/mofed/include:/opt/mellanox/hpcx/mxm/include:/opt/mellanox/hpcx/hcoll/include
prepend-path FPATH /opt/hpe/hpc/openmpi/1.10.4/mofed/include:/opt/mellanox/hpcx/mxm/include:/opt/mellanox/hpcx/hcoll/include
prepend-path MANPATH /opt/hpe/hpc/openmpi/1.10.4/mofed/share/man
prepend-path LIBRARY_PATH /opt/hpe/hpc/openmpi/1.10.4/mofed/lib:/opt/mellanox/hpcx/mxm/lib:/opt/mellanox/hpcx/hcoll/lib
prepend-path LD_LIBRARY_PATH /opt/hpe/hpc/openmpi/1.10.4/mofed/lib:/opt/mellanox/hpcx/mxm/lib:/opt/mellanox/hpcx/hcoll/lib

prepend-path COMM_LDFLAGS "-L/opt/hpe/hpc/openmpi/1.10.4/mofed/lib -L/opt/hpe/hpc/slurm/default/lib -L/opt/mellanox/hpcx/mxm/lib -L/opt/mellanox/hpcx/hcoll/lib -Xlinker -rpath=/opt/hpe/hpc/openmpi/1.10.4/mofed/lib:/opt/hpe/hpc/slurm/default/lib:/opt/mellanox/hpcx/mxm/lib:/opt/mellanox/hpcx/hcoll/lib"

setenv SHMEM_SYMMETRIC_HEAP_SIZE 4500M
setenv SLURM_PMI_KVS_NO_DUP_KEYS 1
setenv MXM_OSHMEM_TLS ud,self
setenv OMPI_MCA_spml_ikrit_hw_rdma_channel 0
setenv OMPI_MCA_pml yalla
setenv MXM_SHM_USE_KNEM_DMA y
setenv OMPI_MCA_sshmem mmap
setenv MXSHMEM_VER 1.10.4_mofed
setenv MXM_FAST_TIMER_RESOLUTION 256.00us
setenv MXM_MPI_TLS ud,shm,self
setenv MXM_UD_FAST_ACK_TIMEOUT 16384.00us

EOF


mkdir -p  %{buildroot}/opt/hpe/hpc/test/installation_validation/openmpi/1.10.4_mofed/
cp /tmp/root/openmpi-1.10.4_mofed-Iv7yZ6s7Y/TESTS/openmpi.ivp %{buildroot}/opt/hpe/hpc/test/installation_validation/openmpi/1.10.4_mofed/ || true
cp /tmp/root/openmpi-1.10.4_mofed-Iv7yZ6s7Y/TESTS/openmpi_1.10.4_mofed.ivp %{buildroot}/opt/hpe/hpc/test/installation_validation/openmpi/1.10.4_mofed
chmod +x %{buildroot}/opt/hpe/hpc/test/installation_validation/openmpi/1.10.4_mofed/* || true

%clean
rm -rf %{buildroot}





%files
%defattr(-,root,root,-)
%{prefix}/*
/opt/hpe/hpc/modules
/opt/hpe/hpc/test

%changelog
